package com.abcseo.ws2300.db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;

/*
 *	Creates the database tables needed for recording temperature data in open2300j
 * 
 * @author david george
 * 
 * (c) 17-July-2005 David George
 * This program is published under the GNU General Public license
 */
public class CreateDB {
	public static void main(String[] args) {
		/*
		 * connect to database
		 */
		try {
			Class.forName("org.hsqldb.jdbcDriver");
		} catch (Exception e) {
			System.out.println("ERROR: failed to load HSQLDB JDBC driver.");
			e.printStackTrace();
			return;
		}
		try {
			Connection c = DriverManager.getConnection(
					"jdbc:hsqldb:file:db/open2300", "sa", "");
			createTables(c);
			c.commit();
			c.close();
		} catch (SQLException e) {
			System.err.println("problem creating database tables " + e);
			System.exit(-1);
		}
		
		System.exit(0);
	}
	
	/**
	 * Create the database tables
	 * 
	 * @param c
	 * @throws SQLException
	 */
	static void createTables(Connection c) throws SQLException {
		   Statement stmt = c.createStatement();
		   
		   stmt.executeUpdate("DROP TABLE Outside_Temp" );
		   System.out.println("Creating Outside_Temp");
		   
		   stmt.executeUpdate("CREATE TABLE Outside_Temp " +
		      "(temperature DOUBLE, time DATETIME)" );
		   stmt.close();
		   System.out.println("Created");
	}
}
