package com.abcseo.ws2300.servlet;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

import javax.servlet.ServletConfig;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.velocity.Template;
import org.apache.velocity.app.Velocity;
import org.apache.velocity.context.Context;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.servlet.VelocityServlet;

import com.abcseo.ws2300.Configuration;

/**
 * 
 * @author David George
 * @author <a href="mailto:david.george@gmail.com">David George</a>
 * @version $Id: $
 * <p>
 * Copyright  2002-5 David George
 * <p>
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 * <p>
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 */
public class ConfigurationServlet extends VelocityServlet {
    protected Properties loadConfiguration(ServletConfig config)
        throws IOException, FileNotFoundException {
        Properties p = new Properties();

        /*
         *  first, we set the template path for the
         *  FileResourceLoader to the root of the 
         *  webapp.  This probably won't work under
         *  in a WAR under WebLogic, but should 
         *  under tomcat :)
         */
        String path = config.getServletContext().getRealPath("/");

        if (path == null) {
            System.out.println(
                " SampleServlet.loadConfiguration() : unable to "
                    + "get the current webapp root.  Using '/'. Please fix.");

            path = "/";
        }

        p.setProperty(Velocity.FILE_RESOURCE_LOADER_PATH, path);

        // same for the log file
        p.setProperty("runtime.log", path + "velocity.log");

        return p;
    }

    /**
     *
     *  @param ctx a Velocity Context object to be filled with
     *             data.  Will be used for rendering this 
     *             template
     *  @return Template to be used for request
     */
    public Template handleRequest(
        HttpServletRequest request,
        HttpServletResponse response,
        Context ctx) {
        Configuration config = null;

        //try {
            config = Configuration.getInstance();


            String action;
            if ((action = request.getParameter("action")) != null) {
            	if (action.equals("shutdown")) {
            		config.shutdown = true;
            	}
            }


            //config.store();
        //} catch (IOException e) {
            // put out some kind of error   
        //}
        ctx.put("config", config);

        /*
         *  Retrieve the template.  There are three possible
         *  exceptions. 
         */
        Template outty = null;

        try {
            outty = getTemplate("configuration.vm");
        } catch (ParseErrorException pee) {
            System.out.println(
                "SampleServlet : parse error for template " + pee);
        } catch (ResourceNotFoundException rnfe) {
            System.out.println("SampleServlet : template not found " + rnfe);
        } catch (Exception e) {
            System.out.println("Error " + e);
        }
        return outty;
    }
}
